{$O-}
Program FixFile;


uses dos;


{**************************************************************************}
{                                                                          }
{  AREAREC Record                                                          }
{                                                                          }
{  The AreaRec record format defines the structure of all *.XFR conference }
{  items (transfer areas).  It is a typed file containing a list of all    }
{  file areas in the transfer conference.                                  }
{                                                                          }
{**************************************************************************}
type arearec=record               {*.XFR Transfer Area record for v2.00 }
     name,                        { Name of xfer volume}
     xmodemdir:string[80];        { Pathname to files in section}
     AccessCode:string[50];       { Access string }
     unu1,
     unu2,
     unu3,
     unu4,
     unu5:byte;                   { Currently unused }
     AskAboutDiz,                 { Allow user to override File_id.DIZ }
     ImportDiz,                   { Import file_id.diz/desc.sdi if it exists }
     ScanAllAreas,                { Scan other areas when uploading }
     ScanThisArea,                { Scan this area in upload scan }
     FreeArea,                    { Free download area }
     NoRatio,                     { Ignore ratio }
     slowdrive:boolean;           { If "Slow drive", like a WORM, the system
                                    wont check for existance of file when
                                    listing files.  Additionally, files will
                                    be copied to the temporary directory
                                    before a download is made }
     unused:integer;              { }
     upload,                      { Allow uploads to section}
     download:boolean;            { Allow downloads from section}
     dataname:string[80];         { Path to the .DIR/.DES data files}
   end;


var
  area:arearec;
  Conf,areanum:byte;
  afile:file of arearec;

function strr (i:integer):string;
var b:string;
begin
  str (i,b);
  strr:=b
end;

procedure convertarea;    {Do the actual area definition}
begin
  with area do begin
    AccessCode:='';
    AskAboutDiz:=true;
    ImportDiz:=true;
    ScanAllAreas:=false;
    ScanThisArea:=true;
    FreeArea:=false;
    NoRatio:=false;
    SlowDrive:=false;
    Upload:=true;
    Download:=true;
   end;
end;

var dir,moo:string;
    DirInfo: SearchRec;      {Dos unit SearchRec}
    P,N,E:string;            {for Fsplit}

  begin   {Display docs}
    writeln('This program will set the extended attributes of a specified file area (FILE.XFR)');
    writeln('or all *.XFR files in a directory to the following settings:');
    writeln;
    writeln('U/L  D/L  Scan  Diz-Opt');
    writeln;
    writeln('These options will be cleared:');
    writeln;
    writeln('Slow  N/R  Free  RSc');
    writeln;
    writeln('This program may be easily modified to make other changes.');
    writeln;

    writeln('2/18/93, 7/14/93 by Brendon Woirhaye  ');
    writeln;
    writeln('It would be prudent to have a backup before running.');

    writeln;
    writeln('Hit ^Break if you have not made a backup.');
    writeln;
    writeln('Please enter the FULL path of your data file(s) to update.  Include drive spec.');
    getdir(0,dir);  {get current path}
    if dir[length(dir)]<>'\' then dir:=dir+'\';  {add slash}
    dir:=dir+'*.XFR';        {Set to all .XFR's in the directory}
    writeln('Or press ENTER for : ',dir);
    write('-->');
    readln(moo);             {Get input from user}
    if length(moo)>3 then dir:=moo;

    {Seek all the areas in conferences}
    FindFirst(Dir, AnyFile, DirInfo);   {Find first one meeting criterion}
    Fsplit(Dir,P,N,E);                  {Split dir into component parts}
    while DosError = 0 do               {Loop through all}
    begin
      writeln('Scanning ',P+DirInfo.Name);
      assign(afile,P+DirInfo.Name);
      reset(afile);

      for areanum:=1 to filesize(afile) do begin
        writeln('  Scanning Area ',areanum);
        seek(afile,areanum-1);
        read(afile,area);
        convertarea;
        seek(afile,areanum-1);
        write(afile,area);
        end;
      close(afile);
      writeln('      Area complete.');
      FindNext(DirInfo);
    end;
  end.

{
 This program is NOT a stunning example of good program code.  It has been
 hacked through about half a dozen programs over three years or so.  Still,
 it is functional and quick.
 }
