program IdReset;


{**************************************************************************}
{                                                                          }
{  USERREC Record                                                          }
{                                                                          }
{  The USERREC record is the format for the USERS file found in the        }
{  Celerity main BBS directory.  It contains the bulk of the information   }
{  about the user's personal details, user configuration, BBS statistics,  }
{  and so forth.  The USERS file is a typed file of USERREC records.       }
{                                                                          }
{  Note: Record #0 of the USERS file should ALWAYS be blank except for the }
{        REALNAME field, which contains the version number of the user     }
{        list in the form "2.00" or "1.42".                                }
{                                                                          }
{**************************************************************************}
type UserRec=record                   {Version 2.00}
     UserID:longint;                  {User identification number}
     Handle:string[30];               {User's handle}
     Realname:string[30];             {User's real first/last name}
     InterNetName:string[15];         {name for internet mail}
     Signature:string[80];            {User's signature}
     Address:array[1..2] of string[30]; {Street Address}
     Macro:array[1..3] of string[30]; {Macros}
		 Note:string[30];                 {User note:  'Sysop of XXX' etc.}
     PrivNote:string[80];             {Sysop note}
		 Password:string[15];             {Password}
		 Phonenum:string[12];             {Phone #.  If blank, user will be prompted}
     DataPhone:string[12];            {Data phone # }
     FaxPhone:string[12];             {Fax phone #}
		 Laston:longint;                  {Last time on in PackTime format}
     NumCalls,                        {Number of calls to system}
		 Udlevel,		       			          {Xfer section access level}
		 Level:integer;                   {Main BBS access level  -5 through 100}
		 HelpLevel:integer;               {Novice / Expert Mode}
		 udpoints:longint;                {Current file points}

     AccessFlags:Longint;             {Access flags #1-32}

     XferConfAccess:longint;          {unused with 2.0}


     AutoChatCall:boolean;            {Call chat upon login}
		 infoforms:array[1..5] of integer;{Location values for Infoforms.  Set to -1}

     InfoScrOffset:array[1..10] of Longint; {unused with 2.0}
     InfoScrSize:Array[1..10] of longint;   {unused with 2.0}

     Color: array[1..8] of byte;  {User's color values.  Setting to 0 will}
		                              {cause system to remap them to the current}
		                              {defaults, as set in setup.}
		 displaylen:byte;        {User's display length.  10-70 lines.}
		 lastmessages,           {Used for determining "how many new posts"}
		 lastups:integer;        {Used to determine the number of new uploads}
     SingleKey:boolean;      {use single key input}
		 defproto:char;          {Default xfer protocol.  Character.}
		 hack:byte;              {Hack attempts since last call.  If >5, ask for phone #}
     AccountCreated:longint; {Date account was created}

     Dummy1:array[1..20] of longint; {unused with 2.0}

     Dummy2,       {unused with 2.0}
     Dummy3:byte;  {unused with 2.0}

     LangSelect,             {Language file preference.  If 0, will ask}
     MenuSelect:byte;        {Menu file preference.  If 0, will ask}

     SpareLongs:array[1..17] of longint;  {unused with 2.0}

		 lastcps,                {Average cps rate for downloading}
		 cpstimes:word;          {Times counted for average}
     CurList:byte;           {Which file list config currently in use?}
		 commpoints,             {Points gained via commission since last call}
		 valpoints:integer;      {Points gained from validation since last call}
		 ScanNet:boolean;        {unused with 2.0}

		 userpcr,                {Individual post/call ratio.  0=use default}
		 userudr,                {Individual upload/download ratio.  0=default}
		 usergenr,               {General ratio}
		 age:byte;               {User's age.  6-89.  If less than 0, user will
          									  be prompted for both age and sex}
     usersex:boolean;        {True=female.  Approved by Deanna Elizalda, Feminist}
		 Expiration,             {Date of account expiration}
		 birthdate:longint;      {date of birth}
		 voteyes,                {Number of votes cast for validation in NUV}
		 voteno:byte;            {Number against user in NUV}
		 timeperday:byte;        {Individual user's time per day.  0=default by lvl}
		 Posts_Month,            {Posts user had at BEGINNING of the month..}
		 Posts_all,              {Total posts user has made}
		 Uploads_Month,          {Uploads user had at the beginning of the month}
		 Uploads_All,            {Total number of uploads}
		 Dnloads_Month,          {Total downloads at beginning of month}
		 Dnloads_all:integer;    {total downloads user has ever made}
		 UpBytes_Month,          {Total bytes uploaded at beginning of month}
		 UpBytes_All,            {Total number of uploaded bytes}
		 DnBytes_Month,          {Bytes downloaded at beginning of month}
		 DnBytes_All:longint;    {Bytes downloaded altogether}
		 PBytes_All,             {Total bytes POSTED by user}
		 PBytes_Month:longint;   {Bytes posted at beginning of this month}
		 KperDay,                {Download k limit per day}
		 KToday:Word;            {K downloaded so far today}
		 NoNet:boolean;          {Deny net access}
		 Exempt:array[1..5] of boolean;
                             {Exemptions: 1-pcr, 2=udr, 3=genr, 4=, 5=xfer}
		 SpecialAccess:boolean;  {unused with 2.0}
     Naplps:boolean;         {Display NAPLPS screens}
     RIP:boolean;            {Use RIP graphics}
     QwkPacker:char;         {code for QWK packer}
     UseYesNo,               {Use YesNo prompts}
     UseFloatPrompt,         {Use floating prompts}
     UseColor:boolean;       {Use color}
     UseSignature:boolean;   {Display signature}
     UseFSE:boolean;         {Use full screen editor}
     PermitPaging:boolean;   {Allow multinode paging & messages}
     SkipTopTen:boolean;     {Do not display top ten}
     SavedTermEmul:byte;     {0=none, 1=vt52, 2=vt52 Atari, 3=vt100, 4=ANSI,
                              5=Avatar level 0}
     SysopFlags:longint;     {sysop flags #1 to 32}

     AreaAccess:longint;     {Unused in 2.0}

     VoteData:array[1..8] of byte;     {vote data - nybbles}
     RemainingTimeCredit:longint;      {Time credit remaining today}
     TermCharacter:longint;  {bitfield:  1=use linefeeds, 2=post prompts,
                                         3=more prompts, 4=8-bit ascii}
     FileList:array[1..3] of longint;  {File listing configuration}
                     {bitfield  1=name, 2=extension, 3=progname, 4=disks,
                                5=size, 6=points, 7=Uploader  8=date u/l
                                9=times d/l, 10=description, 11=skip line}
     TotalTimeOnline:longint;   {Total time user has spent online in minutes}
	  end;



{**************************************************************************}
{                                                                          }
{  SYSTEMCALLSREC Record                                                   }
{                                                                          }
{  This record defines the format of STATUS.DAT in the MAIN BBS Directory. }
{  This file is a typed file, with record #0 containing data for the BBS   }
{  as a whole, and successive records being specific to particular nodes   }
{  (ie: record #1 is for node #1, record #5 for node #5, etc.).            }
{                                                                          }
{**************************************************************************}
type SystemCallsRec=record
     TotalCalls:longint;    { total number of system calls / this node }
     CallsToday,            { calls received today }
     CallsYesterday:word;   { Calls taken yesterday }
     CallsLocal,            { total local calls }
     Calls300,              { total 300bps calls }
     Calls1200,
     Calls2400,
     Calls4800,
     Calls7200,
     Calls9600,
     Calls12000,
     Calls14400,
     Calls16800,
     Calls19200,
     Calls21600,
     Calls24000,
     Calls26400,
     Calls28800,
     Calls38400,
     Calls57600,
     Calls115k:longint;       { total direct-connect 115,200 calls }
     CallsFiler,              { unused }
     CallsNetwork:longint;    { CElerityNet calls }
     CallsLink:longint;       { Link (second/third system) calls }
     DateFirstOnline:longint; { Packtime that this node first came online }
     TotalDaysUp:word;        { number of days node has been up }
     TotalNewUsers:word;      { new users applied on this node }
     TotalUps,                { total uploads on node }
     TotalDns,                { total downloads on node }
     TotalUpK,                { uploaded k   }
     TotalDnK:longint;        { downloaded k }
     TodaysDateTime:longint;  { packtime of last day written to this file }
     MinutesIdle,
     MinutesUsed,
     MinutesXfer:longint;
     TotalSystemIDs:longint;
     SysopAvailable:char;     {Sysop is available}
     ScreenOutput:boolean;    {Screen output is on}
     TotalMessages:word;
     end;







var
   status    :SystemCallsRec;
   f:file of SystemCallsRec;
   ufile:file of UserRec;
   User:UserRec;
   IDNum,cnt:longint;

begin
  writeln('IDRESET.EXE v1.0');
  writeln;
  writeln('This utility will reset the user ID numbers of all users in the current');
  writeln('directory.  Run this utility from your MAIN BBS directory which contains');
  writeln('both USERS and STATUS.DAT.');
  writeln;
  writeln('Having unique user ID numbers is of prime importance with Celerity v2.0.');
  writeln;
  write('Press Ctrl-Break to abort, or [Enter] to continue:');
  readln;
  assign(ufile,'users');
  IDNum:=-1;
  reset(ufile);
  for cnt:=0 to filesize(ufile)-1 do begin
    seek(ufile,cnt);
    read(ufile,user);
    inc(IdNum);
    writeln('Assigning ',idnum,' to ',user.handle);
    user.UserID:=idnum;
    seek(ufile,cnt);
    write(ufile,user);
    end;


 assign(f,'status.dat');
  reset(f);
  seek(f,0);
  read(f,status);
  Status.TotalSystemIDs:=IDNum;
  seek(f,0);
  write(f,status);

end.