program GlobalEdit;


uses dos,crt;

{**************************************************************************}
{                                                                          }
{  USERREC Record                                                          }
{                                                                          }
{  The USERREC record is the format for the USERS file found in the        }
{  Celerity main BBS directory.  It contains the bulk of the information   }
{  about the user's personal details, user configuration, BBS statistics,  }
{  and so forth.  The USERS file is a typed file of USERREC records.       }
{                                                                          }
{  Note: Record #0 of the USERS file should ALWAYS be blank except for the }
{        REALNAME field, which contains the version number of the user     }
{        list in the form "2.00" or "1.42".                                }
{                                                                          }
{**************************************************************************}
type UserRec=record                   {Version 2.00}
     UserID:longint;                  {User identification number}
     Handle:string[30];               {User's handle}
     Realname:string[30];             {User's real first/last name}
     InterNetName:string[15];         {name for internet mail}
     Signature:string[80];            {User's signature}
     Address:array[1..2] of string[30]; {Street Address}
     Macro:array[1..3] of string[30]; {Macros}
		 Note:string[30];                 {User note:  'Sysop of XXX' etc.}
     PrivNote:string[80];             {Sysop note}
		 Password:string[15];             {Password}
		 Phonenum:string[12];             {Phone #.  If blank, user will be prompted}
     DataPhone:string[12];            {Data phone # }
     FaxPhone:string[12];             {Fax phone #}
		 Laston:longint;                  {Last time on in PackTime format}
     NumCalls,                        {Number of calls to system}
		 Udlevel,		       			          {Xfer section access level}
		 Level:integer;                   {Main BBS access level  -5 through 100}
		 HelpLevel:integer;               {Novice / Expert Mode}
		 udpoints:longint;                {Current file points}

     AccessFlags:Longint;             {Access flags #1-32}

     XferConfAccess:longint;          {unused with 2.0}


     AutoChatCall:boolean;            {Call chat upon login}
		 infoforms:array[1..5] of integer;{Location values for Infoforms.  Set to -1}

     InfoScrOffset:array[1..10] of Longint; {unused with 2.0}
     InfoScrSize:Array[1..10] of longint;   {unused with 2.0}

     Color: array[1..8] of byte;  {User's color values.  Setting to 0 will}
		                              {cause system to remap them to the current}
		                              {defaults, as set in setup.}
		 displaylen:byte;        {User's display length.  10-70 lines.}
		 lastmessages,           {Used for determining "how many new posts"}
		 lastups:integer;        {Used to determine the number of new uploads}
     SingleKey:boolean;      {use single key input}
		 defproto:char;          {Default xfer protocol.  Character.}
		 hack:byte;              {Hack attempts since last call.  If >5, ask for phone #}
     AccountCreated:longint; {Date account was created}

     Dummy1:array[1..20] of longint; {unused with 2.0}

     Dummy2,       {unused with 2.0}
     Dummy3:byte;  {unused with 2.0}

     LangSelect,             {Language file preference.  If 0, will ask}
     MenuSelect:byte;        {Menu file preference.  If 0, will ask}

     SpareLongs:array[1..17] of longint;  {unused with 2.0}

		 lastcps,                {Average cps rate for downloading}
		 cpstimes:word;          {Times counted for average}
     CurList:byte;           {Which file list config currently in use?}
		 commpoints,             {Points gained via commission since last call}
		 valpoints:integer;      {Points gained from validation since last call}
		 ScanNet:boolean;        {unused with 2.0}

		 userpcr,                {Individual post/call ratio.  0=use default}
		 userudr,                {Individual upload/download ratio.  0=default}
		 usergenr,               {General ratio}
		 age:byte;               {User's age.  6-89.  If less than 0, user will
          									  be prompted for both age and sex}
     usersex:boolean;        {True=female.  Approved by Deanna Elizalda, Feminist}
		 Expiration,             {Date of account expiration}
		 birthdate:longint;      {date of birth}
		 voteyes,                {Number of votes cast for validation in NUV}
		 voteno:byte;            {Number against user in NUV}
		 timeperday:byte;        {Individual user's time per day.  0=default by lvl}
		 Posts_Month,            {Posts user had at BEGINNING of the month..}
		 Posts_all,              {Total posts user has made}
		 Uploads_Month,          {Uploads user had at the beginning of the month}
		 Uploads_All,            {Total number of uploads}
		 Dnloads_Month,          {Total downloads at beginning of month}
		 Dnloads_all:integer;    {total downloads user has ever made}
		 UpBytes_Month,          {Total bytes uploaded at beginning of month}
		 UpBytes_All,            {Total number of uploaded bytes}
		 DnBytes_Month,          {Bytes downloaded at beginning of month}
		 DnBytes_All:longint;    {Bytes downloaded altogether}
		 PBytes_All,             {Total bytes POSTED by user}
		 PBytes_Month:longint;   {Bytes posted at beginning of this month}
		 KperDay,                {Download k limit per day}
		 KToday:Word;            {K downloaded so far today}
		 NoNet:boolean;          {Deny net access}
		 Exempt:array[1..5] of boolean;
                             {Exemptions: 1-pcr, 2=udr, 3=genr, 4=, 5=xfer}
		 SpecialAccess:boolean;  {unused with 2.0}
     Naplps:boolean;         {Display NAPLPS screens}
     RIP:boolean;            {Use RIP graphics}
     QwkPacker:char;         {code for QWK packer}
     UseYesNo,               {Use YesNo prompts}
     UseFloatPrompt,         {Use floating prompts}
     UseColor:boolean;       {Use color}
     UseSignature:boolean;   {Display signature}
     UseFSE:boolean;         {Use full screen editor}
     PermitPaging:boolean;   {Allow multinode paging & messages}
     SkipTopTen:boolean;     {Do not display top ten}
     SavedTermEmul:byte;     {0=none, 1=vt52, 2=vt52 Atari, 3=vt100, 4=ANSI,
                              5=Avatar level 0}
     SysopFlags:longint;     {sysop flags #1 to 32}

     AreaAccess:longint;     {Unused in 2.0}

     VoteData:array[1..8] of byte;     {vote data - nybbles}
     RemainingTimeCredit:longint;      {Time credit remaining today}
     TermCharacter:longint;  {bitfield:  1=use linefeeds, 2=post prompts,
                                         3=more prompts, 4=8-bit ascii}
     FileList:array[1..3] of longint;  {File listing configuration}
                     {bitfield  1=name, 2=extension, 3=progname, 4=disks,
                                5=size, 6=points, 7=Uploader  8=date u/l
                                9=times d/l, 10=description, 11=skip line}
     TotalTimeOnline:longint;   {Total time user has spent online in minutes}
	  end;


var	urec:userrec;
		ufile:file of userrec;
		cnt,n,numusers:integer;
		choice,temp:char;
    TempS:string;
    TempL:longint;

{**************************************************************************}
{                                                                          }
{  Various Support Procedures and Functions                                }
{                                                                          }
{  These can certainly be improved upon and adapted to other uses.         }
{                                                                          }
{**************************************************************************}

function strr (i:integer):string;
var b:string;
begin
  str (i,b);
  strr:=b
end;

function valu (q:string):integer;  {convert a string to an integer}
var i,s,pu:integer;
    r:real;
begin
  valu:=0;
  if length(q)=0 then exit;
  if not (q[1] in ['0'..'9','-']) then exit;
  if length(q)>5 then exit;
  val (q,r,s);
  if s<>0 then exit;
  if (r<=32767.0) and (r>=-32767.0)
    then valu:=round(r)
end;



function timepart (time:longint):longint;
begin
  timepart:=time and $0000ffff;
end;

function datepart (time:longint):longint;
begin
  datepart:=time and $ffff0000;
end;
procedure parse3 (s:string; var a,b,c:word);
var p:integer;

  procedure parse1 (var n:word);
  var ns:string;
  begin
    ns[0]:=#0;
    while (p<=length(s)) and (s[p] in ['0'..'9']) do begin
      ns:=ns+s[p];
      p:=p+1
      end;
    if length(ns)=0
      then n:=0
      else n:=valu(ns);
    if p<length(s) then p:=p+1
  end;

begin
  p:=1;
  parse1 (a);
  parse1 (b);
  parse1 (c)
end;


function packthetime (var dt:datetime):longint;
var l:longint;
begin
  dos.packtime (dt,l);
  packthetime:=l
end;


function timeval (q:string):longint;
var h1,t:word;
    k:char;
    dt:datetime;
begin
  unpacktime(0,dt);
  parse3 (q,h1,dt.min,t);
  k:=upcase(q[length(q)-1]);
  dt.hour:=h1;
  if k='P' then dt.hour:=dt.hour+12;
  if (dt.hour=24) then
    dt.hour:=0;
  timeval:=timepart(packthetime(dt))
end;

function dateval (q:string):longint;  {return the date part of a packtime}
var dt:datetime;
begin
  unpacktime(0,dt);
  parse3 (q,dt.month,dt.day,dt.year);
  if ((dt.year<100) and (dt.year>00)) then dt.year:=dt.year+1900;
  dateval:=datepart(PackTheTime(dt))
end;


function datestr (time:longint):string;
var dt:datetime;

	function PadZero(s:string):string;
	begin
		if length(s)=1 then
			s:='0'+s;
		PadZero:=s;
		end;
begin
  unpacktime (time,dt);
  datestr:=padzero(strr(dt.month))+'/'+padzero(strr(dt.day))+'/'+strr(dt.year-1900)
end;



function ratio:word;
var ud,temp:longint;
begin
  temp:=urec.upbytes_all;
  if temp<1 then
     ud:=0
  else
     ud:=(temp) div (urec.dnbytes_all div 100);
  if ud>60000 then ud:=60000;
  if ud<0 then ud:=60000;
  ud:=ud+(urec.upbytes_all div 1000000);
  ratio:=ud;
  end;


{**************************************************************************}
{                                                                          }
{  Main program procedures                                                 }
{                                                                          }
{**************************************************************************}

  procedure SetLevels(NewLvl:integer);
  begin
    urec.level:=newlvl;
    urec.udlevel:=newlvl;
    end;

procedure evaluate;
var  oldacc:byte;
begin
  oldacc:=(urec.level + urec.udlevel) div 2;
  if (urec.dnbytes_all>1000000) then begin
     case ratio of
       0:SetLevels(10);
       1..5:SetLevels(15);
       6..10:SetLevels(20);
       11..30:SetLevels(25);
       31..50:SetLevels(30);
       51..60:SetLevels(35);
       61..70:SetLevels(40);
       71..100:SetLevels(45);
       101..60000:SetLevels(50);
       end;
     if urec.upbytes_all<100000 then
       SetLevels(10);

  if (urec.dnbytes_all>1000000) then begin
     case ratio of
       0:SetLevels(-4);
       1..5:SetLevels(10);
       6..10:SetLevels(20);
       11..20:SetLevels(30);
       21..40:SetLevels(40);
       41..50:SetLevels(50);
       51..60:SetLevels(60);
       61..80:SetLevels(70);
       81..100:SetLevels(80);
       101..60000:SetLevels(90);
       end;
     end;


     if urec.level=oldacc then textcolor(7)
     else if urec.level<oldacc then textcolor(red)
     else if urec.level>oldacc then textcolor(green);
     writeln(' Ratio: ',ratio,'%, for level ',urec.level,' access - from ',oldacc);
     textcolor(7);
     end
  else begin
     if (urec.numcalls>15) then
       if (urec.dnbytes_All+urec.upbytes_all)<(urec.numcalls*1) then begin
         SetLevels(-4);
         writeln('  Is a LURKER...');
         end;
       writeln('  is ineligible for evaluation.');
       end;

  end;


procedure convert;
var m,o:integer;
begin
  urec.level:=30;
	case choice of
    'G':with urec do begin
       level:=udlevel;
       if level<21 then begin
            kperday:=1024;
            userudr:=50;
            end
       else if level<31 then begin
            userudr:=30;
            kperday:=2048;
            end
       else if level<41 then begin
            userudr:=20;
            kperday:=2048;
            end
       else if level<61 then begin
            userudr:=0;
            kperday:=3072;
            end;
       end;
		'C':with urec do begin
			 for m:=1 to 8 do color[m]:=0;
		  end;
    'E':urec.expiration:=Templ;
		'U':urec.userudr:=0;
		'T':with urec do begin
				Uploads_Month:=0;
				Uploads_All:=0;
				Dnloads_Month:=0;
				Dnloads_all:=0;
				UpBytes_Month:=0;
				UpBytes_All:=0;
				DnBytes_Month:=0;
				DnBytes_All:=0;
				end;
    'L':begin
        urec.level:=templ;
        urec.udlevel:=templ;
        end;
    'A':if (urec.level<=90) and (urec.level<>55) then Evaluate;
		end;
 end;


  begin
    clrscr;
    writeln;
    writeln('This utility will do various global editing tasks for Celerity/Alacrity v2.0.');
    writeln;
	 writeln('Warning: Make sure you only use this on a version 2.0-compatible userlist.');
   writeln('Use ACCESS EVALUATION only on CAE/TAC');
	 writeln;
	 writeln;
    writeln;
	 writeln('You may reset:      [A]ccess Evaluation   [Q]uit');
	 writeln('  [U]/D Ratios      [T]ransfer Stats      [C]olors');
   writeln('  [E]xpiration date [L]evels (access)     [G]raphex Custom');
    readln(Choice);
	 choice:=upcase(choice);
	 if choice='Q' then exit;

	 case choice of
    'G':begin
        writeln('Setting daily download limits');
        end;
    'L':begin
        writeln('Setting everyone''s access level');
        write('Set access to:');
        readln(temps);
        tempL:=valu(temps);
        end;
		'C':writeln('Setting everyone''s colors to the default.');
		'U':writeln('Setting everyone''s upload/download ratio to 0 (config default)');
		'T':writeln('Clearing everyone''s transfer statistics.');
    'A':writeln('Evaluating access');
    'E':begin
      writeln('Use the format:  07/15/92');
      write('Set expiration date to:');
      readln(temps);
      TempL:=dateval(temps)+timeval('12:00 AM');
      writeln('Setting to : ',datestr(templ));
      end;
		end;


	 assign (ufile,'USERS');
	 reset (ufile);
	 numusers:=filesize(ufile);
	 writeln;
	 seek(ufile,1);
   window(1,12,80,22);
	 for cnt:=1 to (numusers-1) do begin
		seek(ufile,cnt);
		read(ufile,urec);
		gotoxy(1,10);
		write('User #',cnt+1);
		write('    ',urec.handle);

		clreol;
		convert;
    writeln;
		seek(ufile,cnt);
		write (ufile,urec);
	 end;
	 writeln;
	 writeln('Done Converting');
	 close(ufile);
  end.
