{$M $1000,10000,50000 }   { 4K stack, no heap }
{$I+}

program DescScan;

uses dos,crt,DesUnit;

(*  DesUnit contains some ready-made file-handling routines for the
    descriptions.  These procedures are:

procedure ReadMsgData(var offset:longint;var size:word;var data:dataPtr; FN: pathstr);
-- ReadMsgData takes data from Offset/Size and puts it in Data.. (dataPtr is
   defined as "dataPtr=^Byte") out of file FN

procedure SaveMsgData(var Index:MsgIndexRec; IndexLoc: longint; Data:dataPtr; FN: pathstr);
-- Saves Data to file FN.  See the example for its use in descriptions.  MsgIndexRec
   is defined in DesUnit - you can see its structure in Gentypes.  Only the size and
   offset it returns are important for file descriptions.

function NetReset(var af; size:word; mode:byte):byte;
-- Basically a variant of "reset" which supports file locking.  Pass a "mode" to it.
   These are defined in DesUnit as:
   RW      =  Read/Write (normal)
   Locked  =  File is locked
   ReadOnly
   WriteOnly

procedure CopyData(Size:word; var Offset:longint; FromFile,ToFile:Pathstr);
-- CopyData copies data from FromFile to ToFile - size remains the same for both,
   OffSet is initially the offset in the FromFile, and is returned as the offset
   in the ToFile.


PROCEDURE DisplayMsgData(Index: MsgIndexRec; FN: pathstr);
-- Displays raw data from FN.. index needs to include offset/size.  DesUnit's
   DisplayMsgData will also handle pipe commands for color...


Feel free to access these files directly if you like, but we've provided these
procedures to make it easier if you don't mind using someone else's code.

The code in DesUnit is was entirely written by David Hicks and Brendon Woirhaye.
(but it uses the TP DOS unit)
*)



type
		 udrec=record
       sentby:string[30];                 { Who uploaded the file}
       when,                        { When was it uploaded}
       whenrated:longint;           { When was it validated}
       filename,                    { DOS filename}
       dlpw:string[15];                   { Password to download it}
       path:string[50];             { Full pathname pointing to location}
       points:integer;              { Cost to download}
       filesize:longint;            { Size (in bytes)}
       descrip:string[44];          { 44 character description }
       DescOffset,
       DescSize,
       ExtDescOffset,
       ExtDescSize:longint;
       DescLength:byte;
       temp:string[18];
       downloaded:integer;          { Number of times downloaded}
       newfile,                     { Unvalidated file}
       specialfile:boolean;         { Special request}
       progname:string[20];         { This is the full name of the program}
       ofwhat1,ofwhat2:byte;        { These are for "disk x of y"}
       ptsgiven:integer;            { How many validation points awarded}
       private:string[30];                { Who is a private file for}
     end;


var	DirFile:file of UDRec;
    Dirname:string;
    ud:udrec;
    cnt:longint;
    dt:DateTime;
    t:word;
    TimeStamp:longint;
    Uploader:string;
    Path,Temp:string;



PROCEDURE DisplayXferData(Insize,Offset:Longint; FN: pathstr;
                          Column,LineToStart:byte;var LinesToShow:byte);
var
	cnt,
	total,
	numread : word;
	buffer	: array[1..BUFFSIZE] of byte;
	datafile: file;
	datahead: MsgDataHeader;
	Result	: byte;
  Size,
  ReadBuff: longint;
  ShowDisplay:boolean;
  LinesShown,cnt2:byte;

begin
  LinesShown:=0;
  ShowDisplay:=(LineToStart=0);
	cnt		:=0;
	total	:=0;

	if InSize > 0 then begin
		assign(datafile,FN);
		Result:=NetReset(datafile,1,RW);

		If Result = 0 then begin
      if offset>filesize(datafile) then begin
        writeln('>Invalid Description - Please Re-Describe<');
        close(Datafile);
        exit;
        end;
      Seek(DataFile,Offset);
			blockread(datafile,datahead,SizeOf(datahead) );	{Read Data Header}

      Size:=DataHead.Size;


			repeat
        If Size > BUFFSIZE then begin
           ReadBuff:=BUFFSIZE;
           Size:=Size - BUFFSIZE;
           end
        else begin
           ReadBuff:=Size;
           Size:=0;
           end;

				blockread(datafile,buffer,Readbuff,numread);	{Read in buffer}

				for Cnt:=1 to numread do
					if (buffer[cnt]= 13)  then begin
            inc(LinesShown);
            if LinesShown>=LineToStart then
              ShowDisplay:=true;
						if ShowDisplay then begin
              writeln;
              for cnt2:=1 to column do write(' ');
              end;
            end
					else
						if ShowDisplay then write(chr(buffer[cnt]));
			until Size=0;

			end
		else
			writeln('File Busy: ',FN);							{File Locked - Repeat??}

		close(datafile);
		end;

end;


procedure ExtractPathName(fname:string; var path:string; var name:string);
var p:integer;
begin
  path:='';
  repeat
    p:=pos('\',fname);
    if p<>0 then begin
      path:=path+copy(fname,1,p);
      fname:=copy(fname,p+1,255)
    end
  until p=0;
  name:=fname
end;

procedure gifinfo(Gifpath:string);
var
  Gif:file of byte;
  i,j:byte;
  count:longint;
  s:string;
  ch:char;
  bits,colors,width,height:word;
begin
  s:='';
  assign(gif,gifpath);
  reset(gif);
  for count:=1 to 6 do begin
    read(gif,i);
    s:=s+chr(i);
    end;

  if s<>'GIF87a' then begin
    writeln('Not GIF87a');
    close(gif);
    exit;
    end;
  read(gif,i);
  read(gif,j);
  width:=j*256+i;
  read(gif,i);
  read(gif,j);
  height:=j*256+i;
  read(gif,i);
  bits:=i and $07;
  inc(bits);
  colors:=1;
  for i:=1 to bits do colors:=colors*2;
  writeln(width,'x',height,'x',colors);
  close(gif);
end;


procedure GetFileDescript(var ud:udrec);
var       Dummy:msgindexrec;
          IndexLoc:Longint;
          Data,TempData:dataPtr;
          cnt:byte;
          SizeofDesc:word;
          input:string[46];

begin
  SizeofDesc:=0;
  ud.DescLength:=0;
  GetMem(Data,8192);    {get memory for description}
  TempData:=data;
  writeln('Enter the complete file description below.  Hit [Enter] on a blank line to end.');
  writeln(^S'  Ĵ');
  repeat
    write(^P'(>'^W);
    readln(input);
    if input<>'' then begin
      for cnt:=1 to length(input) do begin
        TempData^:=ord(input[cnt]);
        inc(Tempdata);
        inc(SizeOfDesc);
        end;
      tempData^:=13;
      inc(TempData);
      inc(SizeOfDesc);
      inc(ud.DescLength);
      end;
  until (input='');
  if ud.DescLength<1 then begin   {no description left}
    ud.DescSize:=0;
    ud.DescOffset:=0;
    freemem(Data,8192);
    exit;
    end;
  dec(TempData);                { Remove final carriage return }
  dec(SizeOfDesc);
  dec(ud.DescLength);
  Dummy.size:=SizeOfDesc;
  SaveMsgData(Dummy,IndexLoc,Data,Dirname+'.DES');  {Save description}
  freemem(Data,8192);           { Free allocated memory }
  ud.DescSize:=Dummy.Size;
  ud.DescOffset:=Dummy.offset;
end;

procedure EditRecord(var ud:udrec;dirname:string);
var f:file of char;
    k:char;
    done:boolean;
    linesshown:byte;

  procedure ShowUd;
  begin
     writeln ('   Filename: ',ud.filename);
     writeln ('    Program: ',ud.progname);
     writeln ('       Disk: ',ud.ofwhat1,' of ',ud.ofwhat2);
	   writeln ('       Size: ',ud.filesize);
	   writeln ('     Points: ',ud.points);
	   write   ('Description: ');
     LinesShown:=ud.DescSize;
       if LinesShown>7 then LinesShown:=7;
       if ud.DescSize>0 then
         DisplayXferData(ud.DescSize,ud.DescOffset,dirname+'.des',WhereX-1,0,LinesShown);

	   if length(ud.private)>0 then
	   writeln ('Private For: ',ud.private);
	   writeln ('  Times D/L: ',ud.downloaded);
	   writeln ('Unrated/New: ',ud.newfile);
	   writeln ('Special Ask: ',ud.specialfile);
	   writeln ('    Sent by: ',ud.sentby);
	   write   (' Resolution: ');
     GifInfo(ud.path+ud.filename);
     if uploader<>'' then ud.sentby:=Uploader;
     end;

begin
  done:=false;
  ShowUd;
  repeat
     write('(D/V/S/Z/Q/E>');
     repeat until keypressed;
     k:=upcase(readkey);
     writeln;
     case k of
       '?':begin
           write('D)rop to DOS, Z)ip List, V)iew with VPIC, S)kip, E)nter Desc., Q)uit:');
           showud;
           end;

       'D':exec(getenv('comspec'),'');
       'V':exec(getenv('Comspec'),' /c vpic.exe '+ud.path+ud.filename+' /v');
       'S':done:=true;
       'Z':exec(getenv('comspec'),' /c pkzip.exe -v '+ud.path+ud.filename);
       'Q':begin
           close(dirfile);
           halt(0);
           end;
       'E':begin
           GetFileDescript(ud);
           done:=true;
           end;
       end;
  until done;
    ud.specialfile:=false;
    ud.newfile:=false;
    ud.whenrated:=timestamp;
end;


begin
	clrscr;
	writeln;
	writeln('This program will search a Celerity 2.0 directory for files w/out descriptions');
	write('Pathname of directory file to edit (no extension):');
	readln(dirname);
	writeln('Using ',dirname+'.dir');
  write('Uploader name [Enter to leave as-is]:');
  readln(Uploader);

	assign(DirFile,dirname+'.dir');
	{$I-}
	reset(DirFile);
	if ioresult<>0 then begin
    writeln('Error.  File not found.');
    exit;
    end;

  for cnt:=0 to filesize(dirfile)-1 do begin  {seek to all entries in dir}
    seek(dirfile,cnt);
    read(dirfile,ud);
    fillchar(ud.descrip,sizeof(ud.descrip),0);{erase old unused data}
    fillchar(ud.temp,sizeof(ud.temp),0);
    if (ud.DescOffset=0) or (ud.DescSize=0) then begin  {got one w/o desc}
       editrecord(ud,dirname);                          {edit it}
       seek(dirfile,cnt);                               {write the record back}
       write(dirfile,ud);
       end;
		end;
  close(DirFile);
end.

